
/* copyright (c) 1996, 1997, 1998, 1999 William R. Pearson and the
   U. of Virginia */

/* $Name: fa33t09d0 $ - $Id: hxgetaa.c,v 1.7.8.2 2000/10/10 01:11:13 wrp Exp $ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "defs.h"

#define XTERNAL
#include "uascii.h"
#include "upam.h"
#undef XTERNAL

#define TRUE 1
#define FALSE 0
#define MAXLINE 512

static FILE *h_libf=NULL;	/* file pointer for the library file */
long lpos;		/* posn in library of line which is currently in lline */
static char hline[MAXLINE];	/* buffer for library line */

#include "h_altlib.h"
extern int ldnaseq;
int (*h_getlib)();
#define GETLIB agetlib_h

int (*h_getntlib)();
#define GETNTLIB agetntlib_h

static int h_deftype = 0;	/* default library type */
static int h_libtype;		/* current open library type */

/* Opens the given library 
   Seeks to the appropriate position in the library */

int h_openlib (lname, libenv)
char *lname, *libenv;
{
    char libn [120], *bp;
    int opnflg;

/* Build the library name */
    if (strlen (libenv) != 0)
    {
	strncpy (libn, libenv, 120);
	strncat (libn, "/", 120 - strlen (libn));
	strncat (libn, lname, 120 - strlen (libn));
    }
    else
	strncpy (libn, lname, 120);

/* Check for library type */
    if ((bp = strchr (libn, ' ')) != NULL)	/* there is a space in lname */
    {
	*bp = '\0';
	sscanf (bp + 1, "%d", &h_libtype);	/* extract the library type */
	if (h_libtype < 0 || h_libtype > LASTENTRY)
	{
	    fprintf (stderr, "Invalid library type: %d - resetting\n%s\n",
		     h_libtype, lname);
	    h_libtype = h_deftype;
	}
    }
    else					/* default type */
	h_libtype = h_deftype;

/* Open the library */
    if ((h_libf = fopen (libn, "r")) == NULL) {
	fprintf (stderr, "Cannot open %s library\n", libn);
	return -1;
      }

    lpos = ftell (h_libf);		/* Store current position in lpos */
    if (fgets (hline, MAXLINE, h_libf) == NULL) return -1;

    h_getlib = h_getliba [h_libtype];	/* Not implemented */
    h_getntlib = h_getntliba [h_libtype];	/* Not implemented */
    return 1;
  }

/* Closes the library appropriately */
void
h_closelib ()
{
	if (h_libf != NULL) {
	    fclose (h_libf);
	    h_libf = NULL;
	}
    }

void reseq (lmark)
     long lmark;
{
    fseek (h_libf, lmark, 0);
    lpos = ftell (h_libf);
    fgets (hline, MAXLINE, h_libf);
}

GETLIB (seq, maxs, libstr, libpos, lcont)
char *seq;              /* space for library sequence */
int maxs;               /* Maximum size */
char *libstr;           /* Descriptive line */
long *libpos;           /* Offset of beginning of sequence */
int *lcont;             /* Flag indicating continued sequence */
{
    register char *cp;
    register char *seqp;
    register int  *ap;
    char  *seqm,  *seqm1, *bp;

    seqp  = seq;
    seqm  = &seq[maxs - 9];
    seqm1 = seqm - 1;

    ap = sascii;
    if (*lcont == 0) 
    {
	while (hline[0] != '>' && hline[0] != ';') {
	  lpos = ftell(h_libf);
	  if (fgets (hline, MAXLINE, h_libf) == NULL) return -1;
	  }

/* Fetch descriptive line */
	strncpy (libstr, hline, MAX_FN);
	libstr[MAX_FN-1] = '\0';

	if ((bp=strchr(libstr,'\n'))!=NULL) *bp='\0';
	*libpos = lpos;

	/* make certain we have the end of the line */
	while (strchr((char *)hline,'\n')==NULL) {
	  if (strlen(hline)<MAXLINE/2) 
	    fgets(&hline[strlen(hline)],MAXLINE/2,h_libf);
	  else 
	    fgets(&hline[MAXLINE/2],MAXLINE/2,h_libf);
	}
    }

    hline[0]='\0';
    while (seqp<seqm1 && fgets(seqp,(int)(seqm-seqp),h_libf)!=NULL) 
    {
	if (*seqp == '>') goto new;
	if (*seqp == ';') 
	{
	    if (strchr (seqp, '\n') == NULL) 
		goto cont;
	    continue;
	}
	for (cp = seqp; seqp < seqm1; ) 
	{
	    if ((*seqp++ = ap[*cp++]) < NA &&
		(*seqp++ = ap[*cp++]) < NA &&
		(*seqp++ = ap[*cp++]) < NA &&
		(*seqp++ = ap[*cp++]) < NA &&
		(*seqp++ = ap[*cp++]) < NA &&
		(*seqp++ = ap[*cp++]) < NA &&
		(*seqp++ = ap[*cp++]) < NA &&
		(*seqp++ = ap[*cp++]) < NA &&
		(*seqp++ = ap[*cp++]) < NA) 
		continue;
   	    if (*(--seqp) > NA) 
		break;
	}
	if (*seqp == ES) 
	    goto done;
	lpos = ftell(h_libf);
    }
    goto done;
new:strncpy(hline, seqp, MAXLINE);
    hline[MAXLINE - 1] = '\0';
    if (strchr (seqp, '\n') == NULL) 
	fgets (hline, MAXLINE - strlen(hline), h_libf);
    goto done;

cont:
    fgets (hline, MAXLINE, h_libf);
    seqm1 = seqp;

done:if (seqp >= seqm1) 
    	(*lcont)++;
    else 
    	*lcont = 0;

    *seqp = EOSEQ;
    return (int) (seqp - seq);
}

GETNTLIB (seq, maxs, libstr, libpos, lcont)
char *seq;              /* space for library sequence */
int maxs;               /* Maximum size */
char *libstr;           /* Descriptive line */
long *libpos;           /* Offset of beginning of sequence */
int *lcont;             /* Flag indicating continued sequence */
{
    register char *cp;
    register char *seqp;
    register int  *ap;
    char  *seqm,  *seqm1, *bp;

    seqp  = seq;
    seqm  = &seq[maxs - 9];
    seqm1 = seqm - 1;

    ap = nascii;
    if (*lcont == 0) 
    {
	while (hline[0] != '>' && hline[0] != ';') {
	  lpos = ftell(h_libf);
	  if (fgets (hline, MAXLINE, h_libf) == NULL) return -1;
	  }

/* Fetch descriptive line */
	strncpy (libstr, hline, MAX_FN);
	libstr[MAX_FN-1] = '\0';
	if ((bp=strchr(libstr,'\n'))!=NULL) *bp='\0';
	*libpos = lpos;
    }

    hline[0]='\0';
    while (seqp<seqm1 && fgets(seqp,(int)(seqm-seqp),h_libf)!=NULL) 
    {
	if (*seqp == '>') goto new;
	if (*seqp == ';') 
	{
	    if (strchr (seqp, '\n') == NULL) 
		goto cont;
	    continue;
	}
	for (cp = seqp; seqp < seqm1; ) 
	{
	    if ((*seqp++ = ap[*cp++]) < NA &&
		(*seqp++ = ap[*cp++]) < NA &&
		(*seqp++ = ap[*cp++]) < NA &&
		(*seqp++ = ap[*cp++]) < NA &&
		(*seqp++ = ap[*cp++]) < NA &&
		(*seqp++ = ap[*cp++]) < NA &&
		(*seqp++ = ap[*cp++]) < NA &&
		(*seqp++ = ap[*cp++]) < NA &&
		(*seqp++ = ap[*cp++]) < NA) 
		continue;
   	    if (*(--seqp) > NA) 
		break;
	}
	if (*seqp == ES) 
	    goto done;
	lpos = ftell(h_libf);
    }
    goto done;
new:strncpy(hline, seqp, MAXLINE);
    hline[MAXLINE - 1] = '\0';
    if (strchr (seqp, '\n') == NULL) 
	fgets (hline, MAXLINE - strlen(hline), h_libf);
    goto done;

cont:
    fgets (hline, MAXLINE, h_libf);
    seqm1 = seqp;

done:if (seqp >= seqm1) 
    	(*lcont)++;
    else 
    	*lcont = 0;

    *seqp = EOSEQ;
    return (int) (seqp - seq);
}

vgetlib_h(seq,maxs,libstr,libpos,lcont)
	char *seq;
	int maxs;
	char *libstr;
	long *libpos;
	int *lcont;
{
	int i, n, ll;
	int ic;
	register char *cp;
	register char *seqp;
	register int *ap;
	char *seqm, *seqm1, *linep, *bp;

	seqp = seq;
	seqm = &seq[maxs-9];
	seqm1 = seqm-1;
#ifndef TFASTA
	ap = sascii;
#else
	ap = nascii;
#endif
	if (*lcont==0) {
		while (hline[0]!='>' && hline[0]!=';') {
			lpos = ftell(h_libf);
			if (fgets(hline,MAXLINE,h_libf)==NULL) return 0;
		}
		if ((bp=strchr(hline,'\n'))!=NULL) *bp='\0';
		strncpy(libstr,&hline[4],MAX_FN);
		fgets(hline,MAXLINE,h_libf);
		strncat(libstr,hline,MAX_FN);
		libstr[MAX_FN-1]='\0';
		*libpos = lpos;
		}

	hline[0]='\0';
	while (seqp<seqm1 && fgets(seqp,(int)(seqm-seqp),h_libf)!=NULL) {
		if (*seqp=='>') goto new;
		if (*seqp==';') {
			if (strchr(seqp,'\n')==NULL) goto cont;
			continue;
			}
		for (cp=seqp; seqp<seqm1; ) {
			if ((*seqp++=ap[*cp++])<NA &&
			    (*seqp++=ap[*cp++])<NA &&
		            (*seqp++=ap[*cp++])<NA &&
		            (*seqp++=ap[*cp++])<NA &&
			    (*seqp++=ap[*cp++])<NA &&
			    (*seqp++=ap[*cp++])<NA &&
			    (*seqp++=ap[*cp++])<NA &&
			    (*seqp++=ap[*cp++])<NA &&
			    (*seqp++=ap[*cp++])<NA) continue;
			    if (*(--seqp)>NA) break;
			    }
		if (*seqp==ES) goto done;
		lpos = ftell(h_libf);
		}
	goto done;
new:	strncpy(hline,seqp,MAXLINE);
	hline[MAXLINE-1]='\0';
	if (strchr(seqp,'\n')==NULL) fgets(hline,MAXLINE-strlen(hline),h_libf);
	goto done;

cont:
	fgets(hline,MAXLINE,h_libf);
	seqm1 = seqp;

done:
	if (seqp>=seqm1) {
	  (*lcont)++;
	}
	else {
	  *lcont=0;
	}
	

	*seqp = EOSEQ;
	if ((int)(seqp-seq)==0) return 1;
	return (int)(seqp-seq);
	}

#ifndef MPI
void
revcomp(seq,n)
	unsigned char *seq; int n;
{
  unsigned char tmp;
  int i, ni;

  for (i=0; i< n; i++)
    if (nt[seq[i]]=='A') seq[i] = nascii['T'];
    else if (nt[seq[i]]=='C') seq[i] = nascii['G'];
    else if (nt[seq[i]]=='G') seq[i] = nascii['C'];
    else if (nt[seq[i]]=='T') seq[i] = nascii['A'];
    else if (nt[seq[i]]=='R') seq[i] = nascii['Y'];
    else if (nt[seq[i]]=='Y') seq[i] = nascii['R'];
    else if (nt[seq[i]]=='M') seq[i] = nascii['K'];
    else if (nt[seq[i]]=='K') seq[i] = nascii['M'];
    else if (nt[seq[i]]=='D') seq[i] = nascii['H'];
    else if (nt[seq[i]]=='H') seq[i] = nascii['D'];
    else if (nt[seq[i]]=='V') seq[i] = nascii['B'];
    else if (nt[seq[i]]=='B') seq[i] = nascii['V'];

  for (i=0, ni = n-1; i< n/2; i++,ni--) {
    tmp = seq[i];
    seq[i] = seq[ni];
    seq[ni] = tmp;
  }
}
#endif
