/* copyright (c) 1996, 1997, 1998, 1999 William R. Pearson and the
   U. of Virginia */

/* $Name: fa33t09d0 $ - $Id: pxgetaa.c,v 1.10 2000/07/21 22:41:22 wrp Exp $ */

/* Concurrent read version */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "mw.h"
#define XTERNAL
#include "uascii.h"
#include "upam.h"
#define TRUE 1
#define FALSE 0
#define MAXLINE 512

#ifndef SFCHAR
#define SFCHAR '|'
#endif

long libf = -1;		/* file descriptor for library */
static long lpos;	/* posn in library of line which is currently in lline */
static char lline[MAXLINE];	/* buffer for library line */
static char *buff;		/* big buffer for cread */
static int  rindx = 0;	/* read index into big buffer */
static int  windx = 0;	/* write index into big buffer */
static long ofst = 0L;	/* offset into library */

#include "p_altlib.h"
#include <fcntl.h>

extern int ldnaseq;
int (*getlib)();
#define GETLIB agetlib
void sf_sort(int *, int);

/* the following is from fgetgb.c */

#define DEFTYPE 0	/* default library type */
int libtype;		/* current open library type */

/* Opens the given library 
   Seeks to the appropriate position in the library */

#define SQSZ	100000
int openlib (char  *lname, char  *libenv, long lboff, long lbstop, long lbsize)
{
  char libn [120], *bp;
  int opnflg;
  long len;

/* Build the library name */
  if (*libenv != '\0')  {
    strncpy (libn, libenv, 120);
    strncat (libn, "/", 120);
    strncat (libn, lname, 120 - strlen (libn));
  }
  else strncpy (libn, lname, 120);

/* Check for library type */
  if ((bp = strchr (libn, ' ')) != NULL) {	/* there is a space in lname */
    *bp = '\0';
    sscanf (bp + 1, "%d", &libtype);	/* extract the library type */
    if (libtype < 0 || libtype > LASTENTRY) {
      fprintf (stderr, "Invalid library type: %d - resetting\n%s\n",
	       libtype, lname);
      libtype = DEFTYPE;
    }
  }
  else libtype = DEFTYPE;	/* default type */
	

/* Open the library */
  if ((libf = (long) open (libn, O_RDONLY)) == (long) (-1))
    {
      fprintf (stderr, "Unable to open %s library\n", libn);
      fflush (stderr);
      return -1;
    }

  /* Seek to proper position */
  lseek (libf, lboff, 0);		/* seek to given offset */
  ofst = lboff;			/* Remember offset into lib */
  len = (long) (lbstop - lboff);	/* Read your chunk in */
  if (lbstop < lbsize)		/* not yet at end of library */
    {
      if ((lbsize - lbstop) >= SQSZ)	/* more than SQSZ more bytes left */
	len += SQSZ;			/* read only SQSZ extra */
      else				/* less than SQSZ left */
	len += (lbsize - lbstop);	/* read to end of library */
    }
  else if (lbstop > lbsize)		/* attempt to read past end of file */
    len = (long) (lbsize - lboff);

  if ((buff=malloc(len+1))==NULL) {
    fprintf(stderr," cannot allocate read buffer %ld\n",len+1);
    exit(1);
  }

  read (libf, buff, len);		/* Read the data */
  buff [len] = (char)EOF;
  rindx = windx = 0;			/* set rindx and windx to beginning */

  getlib = getliba[libtype];		/* Select getlib */
  return 1;
}

/* Closes the library appropriately */
void
closelib ()
{
    close (libf);
    libf = -1;
}

char *getbuff (s, n)
char *s;
int n;
{
    char *cs;

    cs = s;
    while (--n > 0 && (buff[rindx] != (char)EOF))
	if ((*cs++ = buff [rindx++]) == '\n') break;
    *cs = '\0';
    return ((buff[rindx] == (char)EOF && cs == s) ? NULL : s);
}

/* Fetch library sequence, process it some 
   and return comprehensible stuff back to caller */

GETLIB (char **aa1, char *libstr, long *libpos, int *sfnum) {
    register int *ap;
    int oindx, i, nsf, long_comment;
    char *bp, *bp1, *tp;
    unsigned char *cp;

    sfnum[0] = 0;
    oindx = windx;
#ifndef TFASTX
    ap = sascii;
#else
    ap = nascii;
#endif
    while (lline [0] != '>' && lline [0] != ';') 
    {						/* forward to new sequence */
	lpos = ofst + (long) rindx;		/*current index into library */
	if (getbuff (lline, MAXLINE) == NULL) return 0;
    }

/* Descriptive line */
    strncpy(libstr, &lline[1], 255);
    libstr [255] = '\0';
    if ((bp=strchr(libstr,'\n'))!=NULL) *bp='\0';
    long_comment = (strchr(lline,'\n')==NULL);

    sfnum[0]=nsf=0;
    if ((bp=strchr(lline,SFCHAR))!=NULL) {
      if ((bp1=strchr(bp+1,SFCHAR))==NULL) {
/*	fprintf(stderr," second %c missing: %s\n",SFCHAR,libstr); */
      }
      else {
	*bp1 = '\0';
	i = 0;
	if ((tp = strtok(bp+1," \t"))!=NULL) {
	  sfnum[i++] = atoi(tp);
	  while ((tp = strtok(NULL," \t")) != NULL) {
	    sfnum[i++] = atoi(tp);
	    if (i>=10) break;
	  }
	}
	sfnum[nsf=i]= 0;
	if (nsf>0) sf_sort(sfnum,nsf);
      }
    }
    *libpos = lpos;		/* beginning of sequence */

    /* make certain we have the end of the line */

    

    if (long_comment) {
      do  {
	getbuff(lline,MAXLINE);
      } while (strchr(lline,'\n')==NULL);
    }

    lline[0] = '\0';
    while (getbuff (lline, MAXLINE) != NULL) 
    {
	if (lline [0] == '>') 			/* next sequence */
	    goto done;
	for (cp = (unsigned char *)lline; *cp;) 	/* process sequence */
	{
	    if ((buff[windx++] = ap[*cp++]) < NA &&
	        (buff[windx++] = ap[*cp++]) < NA &&
	        (buff[windx++] = ap[*cp++]) < NA &&
	        (buff[windx++] = ap[*cp++]) < NA &&
	        (buff[windx++] = ap[*cp++]) < NA &&
	        (buff[windx++] = ap[*cp++]) < NA &&
	        (buff[windx++] = ap[*cp++]) < NA &&
	        (buff[windx++] = ap[*cp++]) < NA &&
	        (buff[windx++] = ap[*cp++]) < NA) 
		continue;
	    if (buff[--windx] > NA) 
		break;
	}
	if (buff[windx] == ES) 		/* done with this sequence */
	    goto done;
	lpos = ofst + (long) rindx;
    }

done:
    buff[windx] = EOSEQ;
    windx++;
    *aa1 = &buff[oindx];
    return (windx - oindx - 1);		/* return number of chars read */
}

#define CNT 256

lgetlib(char **seq, char *libstr, long *libpos, int *sfnum)
{
  register int *ap;
  char *bp, *tp;
  unsigned char *cp;
  int oindx, i;

  char desc[MAXLINE], acc[MAXLINE];

#if !defined(TFASTX)
  ap = sascii;
#else
  ap = nascii;
#endif

  sfnum[0]=0;
  oindx = windx;

  while (lline[0]!='L' || lline[1]!='O' || 
	 strncmp(lline,"LOCUS",5)) { /* find LOCUS */
    lpos = ofst + (long)rindx;
    if (getbuff(lline,MAXLINE)==NULL) return -1;
  }
  *libpos=lpos;

  strncpy(libstr,&lline[12],12);
  libstr[12]='\0';
  if ((bp=strchr(libstr,' '))!=NULL) *bp = '\0';

  getbuff(desc,MAXLINE);
  while (desc[0]!='D' || desc[1]!='E' || 
	 strncmp(desc,"DEFINITION",10)) { /* find DEFINITION */
    if (getbuff(desc,MAXLINE)==NULL) return -1;
  }
  if ((bp = strchr(&desc[12],'\n'))!=NULL) *bp='\0';

  getbuff(acc,MAXLINE);
  while (acc[0]!='A' || acc[1]!='C' || 
	 strncmp(acc,"ACCESSION",9)) { /* find ACCESSION */
    if (getbuff(acc,MAXLINE)==NULL) return -1;
  }

  if ((bp = strchr(&acc[12],'\n'))!=NULL) *bp='\0';
  if ((bp = strchr(&acc[12],' '))!=NULL) *bp='\0';

  /* add accession to locus */
  if ((bp=strchr(&desc[12],' '))!=NULL) {
    *bp = '\0';
    if (strcmp(&acc[12],&desc[12])==0) {
      *bp = ' ';
      strncat(libstr,&desc[11],CNT-strlen(libstr));
    }
    else {
      *bp = ' ';
      strncat(libstr,&acc[11],CNT-strlen(libstr));
      strncat(libstr,&desc[11],CNT-strlen(libstr));
    }
  }
  else {
    strncat(libstr,&acc[11],CNT-strlen(libstr));
    strncat(libstr,&desc[11],CNT-strlen(libstr));
  }    
  libstr[CNT-1]='\0';  

  getbuff(lline,MAXLINE);
  while (lline[0]!='O' || lline[1]!='R' ||
	 strncmp(lline,"ORIGIN",6)) { /* find ORIGIN */
    if (getbuff(lline,MAXLINE)==NULL) return -1;
  }

  lline[0]='\0';
  while (getbuff(lline,MAXLINE)!=NULL) {
    if (lline[0]=='/') goto done;
    for (cp= (unsigned char *)&lline[10]; *cp; ) {
      if ((buff[windx++]=ap[*cp++])<NA &&
	  (buff[windx++]=ap[*cp++])<NA &&
	  (buff[windx++]=ap[*cp++])<NA &&
	  (buff[windx++]=ap[*cp++])<NA &&
	  (buff[windx++]=ap[*cp++])<NA &&
	  (buff[windx++]=ap[*cp++])<NA &&
	  (buff[windx++]=ap[*cp++])<NA &&
	  (buff[windx++]=ap[*cp++])<NA &&
	  (buff[windx++]=ap[*cp++])<NA &&
	  (buff[windx++]=ap[*cp++])<NA &&
	  (buff[windx++]=ap[*cp++])<NA) continue;
      if (buff[--windx] > NA) break;
    }
  }

done:
  buff[windx++] = EOSEQ;
  *seq = &buff[oindx];

  return (windx - oindx - 1);
}

/* Fetch library sequence, process it some 
   and return comprehensible stuff back to caller */
vgetlib (char **seq, char *libstr, long *libpos, int *sfnum)
{
    register int *ap;
    char *bp, *tp;
    int oindx, i, nsf;

    oindx = windx;
#ifndef TFASTX
    ap = sascii;
#else
    ap = nascii;
#endif
    while (lline[0] != '>' && lline[0] != ';') { /* forward to new sequence */
	lpos = ofst + (long) rindx;	      /* current index into library */
	if (getbuff (lline, MAXLINE) == NULL) return 0;
    }

/* Descriptive line */
    if (lline [0] == '>' && (lline [3]==';' || lline[3]=='|')) {
      if ((bp=strchr(lline,SFCHAR)) !=NULL) {
	i = 0;
	if ((tp = strtok(bp+1," \t\n"))!=NULL) {
	  sfnum[i++] = atoi(tp);
	  while ((tp = strtok(NULL," \t\n")) != NULL) {
	    sfnum[i++] = atoi(tp);
	    if (i>=10) break;
	  }
	}
	sfnum[nsf=i]= 0;
	if (nsf>0) sf_sort(sfnum,nsf);
	else
	  fprintf(stderr," found | but no sfnum: %s\n",lline);
      }
      else {sfnum[0] = 0; nsf = 0;}
      strncpy (libstr, &lline[4], 255);
      /*
      if (nsf>0) {
	fprintf(stderr,"%s:",libstr);
	for (i=0; sfnum[i]>0; i++) fprintf(stderr," %3d",sfnum[i]);
	fprintf(stderr,"\n");
      }
      */
    }
    else strncpy (libstr, &lline[1], 255);
    libstr[255]='\0';
    if ((bp = strchr(libstr,'\n'))!= NULL) *bp = '\0';

    getbuff (lline, MAXLINE);
    if ((bp = strchr (lline,'\n')) != NULL) *bp = '\0';
    strcat (libstr, " ");
    strncat (libstr, lline, 255-strlen (libstr));
    libstr[255]='\0';
    if ((bp = strchr (libstr, '\n')) != NULL) *bp = '\0';

    *libpos = lpos;		/* beginning of sequence */

    lline[0] = '\0';
    while (getbuff (lline, MAXLINE) != NULL) {
        if (lline [0] == '>') goto done; /* next sequence */
        for (i = 0; i < MAXLINE;) {      /* process sequence */
	  if ((buff[windx++] = ap[lline[i++]]) < NA &&
                (buff[windx++] = ap[lline[i++]]) < NA &&
                (buff[windx++] = ap[lline[i++]]) < NA &&
                (buff[windx++] = ap[lline[i++]]) < NA &&
                (buff[windx++] = ap[lline[i++]]) < NA &&
                (buff[windx++] = ap[lline[i++]]) < NA &&
                (buff[windx++] = ap[lline[i++]]) < NA &&
                (buff[windx++] = ap[lline[i++]]) < NA &&
                (buff[windx++] = ap[lline[i++]]) < NA) 
                continue;
            if (buff[--windx] > NA) 
                break;
        }
        if (buff[windx] == ES)          /* done with this sequence */
            goto done;
	lpos = ofst + (long) rindx;
    }

done:
    buff[windx] = EOSEQ;
    windx++;
    *seq = &buff[oindx];
    return (windx - oindx - 1);
}


void
sf_sort(int *s, int n)
{
  int gap, i, j;
  int itmp;
	
  for (i=0; i<n-1; i++)
    if (s[i]>s[i+1]) goto l2;
  return;

l2:
  for (gap=n/2; gap>0; gap/=2)
    for (i=gap; i<n; i++)
      for (j=i-gap; j>=0; j -= gap) {
	if (s[j] <= s[j+gap]) break;
	itmp = s[j];
	s[j]=s[j+gap];
	s[j+gap]=itmp;
      }
}

max (arg1, arg2)
int arg1, arg2;
{
    return (arg1 > arg2) ? arg1 : arg2;
}
