#!/bin/csh -f
echo ""
echo "starting fasta33_t - protein" `date` "on" `hostname`
echo `uname -a`
echo ""
fasta33_t -q -m 6 -Z 100000 mgstm1.aa:1-100 q > test_m1.ok2_t.html
fasta33_t -S -q -z 11 -O test_m1.ok2_t_p25 -s P250 mgstm1.aa:100-218 q
echo "done"
echo "starting fastxy33_t" `date`
fastx33_t -m 9 -S -q mgtt2_x.seq q 3 > test_t2.xk2_t
fasty33_t -S -q mgtt2_x.seq q > test_t2.yk2_t
fastx33_t -m 9 -S -q -z 2 mgstm1.esq a > test_m1.xk2_tz2
fasty33_t -S -q -z 2 mgstm1.esq a > test_m1.yk2_tz2
echo "done"
echo "starting fastxy33_t rev" `date`
fastx33_t -m 9 -q -m 5 mgstm1.rev q > test_m1.xk2r_t
fasty33_t -q -m 5 -M 200-300 -z 2 mgstm1.rev q > test_m1.yk2r_tz2
fasty33_t -q -m 5 -z 11 mgstm1.rev q > test_m1.yk2rz11_t
echo "done"
echo "starting ssearch33_t" `date`
ssearch33_t -m 9 -S -z 3 -q mgstm1.aa  q > test_m1.ss_tz3
ssearch33_t -q -M 200-300 -z 2 -Z 100000 -s P250 mgstm1.aa q > test_m1.ss_t_p25
echo "done"
echo "starting fasta33_t - DNA" `date`
fasta33_t -q -z 2 mgstm1.seq %RMB 4 > test_m1.ok4_tz2
fasta33_t -q -r +1/-3 mgstm1.rev %RMB > test_m1.ok4r_t
echo "done"
echo "starting tfasta33_t" `date`
tfasta33_t -q mgstm1.aa %RMB > test_m1.tk2_t
echo "done"
echo "starting tfastxy33_t" `date`
tfastx33_t -m 9 -q -i -3 mgstm1.aa %p > test_m1.tx2_t
tfasty33_t -q -i -3 -N 5000 mgstm1.aa %p > test_m1.ty2_t
echo "done"
echo "starting fastf33_t" `date`
fastf33_t -q m1r.aa q > test_mf.ff_s
echo "done"
echo "starting tfastf33_t" `date`
tfastf33_t -q -E 0.0001 m1r.aa %r > test_mf.tf_r
echo "done"
echo "starting fasts33_t" `date`
fasts33_t -q n0.aa q > test_m1.fs_s
echo "done"
echo "starting tfasts33_t" `date`
tfasts33_t -q n0.aa %r > test_m1.ts_r
echo "done"
echo "starting fasta33 - protein" `date`
fasta33 -q -z 2 mgstm1.aa q > test_m1.ok2z2
fasta33 -q -s P250 mgstm1.aa q > test_m1.ok2_p25 
echo "done"
echo "starting fastx3" `date`
fastx33 -m 9 -q mgstm1.esq q > test_m1.ok2x 
echo "done"
echo "starting fasty3" `date`
fasty33 -q mgstm1.esq q > test_m1.ok2y 
echo "done"
echo "starting fasta33 - DNA " `date`
fasta33 -m 9 -q mgstm1.seq %RMB 4 > test_m1.ok4 
echo "done"
echo "starting ssearch3" `date`
ssearch33 -S -q -z 2 mgstm1.aa q > test_m1.ss_z2
ssearch33 -q -s P250 mgstm1.aa q > test_m1.ss_p25 
echo "done"
echo "starting tfasta3" `date`
tfasta33 -q mgstm1.aa %RMB > test_m1.tk2 
echo "done"
echo "starting tfastxy3" `date`
tfastx33 -q mgstm1.aa %RMB > test_m1.tx2 
tfasty33 -m 9 -q mgstm1.aa %RMB > test_m1.ty2 
echo "done" `date`
echo "starting prss3" `date`
prss33 -q mgstm1.aa xurt8c.aa 1000 > test_m1.rss1
prss33 <<EOF
mgstm1.aa
xurt8c.aa
500
w

test_m1.rss2
EOF
echo "done" `date`
