
/* $Name: fa33t09d0 $ - $Id: w_mw.h,v 1.8.6.1 2001/03/28 23:06:19 wrp Exp $ */

/* 21-July-2000 - changes for p2_complib/p2_workcomp:
   there are now two sequence numbers; the old (worker) seqnm,
   and a new manager (master) sequence number, m_seqnm
*/

#ifndef BFR
#define BFR	300
#endif
#ifndef BFR2
#define BFR2	100
#endif

#define MAXSQL	125000
#define MAXWRKR	64
#define MAXLSEQ	50000
#define DESLIN	60
#define NDES	100

struct qmng_str
{
  int n0;	/* query sequence length */
  int s_func;	/* for p_workcomp: func==0>simple comparison, ==1>alignments */
  int slist;	/* number of alignments to do */
  int seqnm;	/* query sequence number - used for identity searches */
  char libstr[MAX_FN];
};

struct comstr
{
  int m_seqnm;		/* sequence number */
  int seqnm;		/* sequence number */
  int score[3];		/* score */
  int rscore;
  float comp;
  float H;
  int frame;
};

struct comstr2
{
  int m_seqnm;		/* sequence number */
  int seqnm;		/* sequence number */
  int score[3];		/* score */
  int swscore;

  /* int a_len; */	/* consensus alignment length */
  /* int min0, max0, min1, max1;
  int nident, ngap_q, ngap_l; */ /* number of identities, gaps in q, l */
  
  struct a_struct aln_d;
  float percent, gpercent;
};

/* The message structure */

struct wrkmsg
{
    char lname [80];	/* name of the library */
    char libenv[80];	/* directory in which library resides */
    int lb_off;		/* offset in the library */
    int lb_stop;	/* stop position in library */
    int lb_code;	/* continue code */
    int lb_size;	/* library size */
    int p_size;		/* parcel size */
    int libfn;		/* current library being searched */
    int stage;		/* current stage number */
};

struct timmsg
{
    unsigned int cv1;	/* time spent waiting for work */
    unsigned int cv2; 	/* time spent waiting to  send */
    unsigned int ttim; /* total time */
};

struct sqlc
{
  int n1;
  int sfnum[10];	/* superfamily number */
#ifndef USE_FSEEKO
  long lseek;
#else
  off_t lseek;
#endif
  long loffset;		/* offset from the beginning of the sequence */
  int wrkr;		/* worker that has sequence */
  int flib;		/* library file */
  int cont;
  char bline[256];	/* descriptive line */
};

struct sql
{
  int n1;
  int sfnum[10];	/* superfamily number */
#ifndef USE_FSEEKO
  long lseek;
#else
  off_t lseek;
#endif
  long loffset;		/* offset from the beginning of the sequence */
  int wrkr;		/* worker that has sequence */
  int flib;		/* library file */
  int cont;
  char *bline;	/* descriptive line */
};

struct sqs
{
  int n1;		/* size of library sequence */
  unsigned char *aa1; 	/* sequence data */
};

struct sqs2
{
  int n1;		/* size of library sequence */
  int m_seqnm;		/* location in master list */
  unsigned char *aa1;
};

struct stage2_str {
  int m_seqnm;	/* manager sequence number */
  int seqnm;	/* worker sequence number */
  int frame;	/* query frame */
};
